package com.fp.persistence.pbpm.gene;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.util.List;

import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.Query;
import javax.persistence.Table;
import javax.persistence.Transient;

import com.fp.dto.hb.HibernateBean;

/** Clase que implementa la entidad de Hibernate que hace referencia a la tabla TBPMFIELDTRANSACTIONMAPING */
@Entity(name = "TbpmFieldTransactionMaping")
@Table(name = "TBPMFIELDTRANSACTIONMAPING")
public class TbpmFieldTransactionMaping extends com.fp.dto.AbstractDataTransport implements Serializable,
        HibernateBean, Cloneable {
    /**
     * HashCode asociado con la Instancia
     */
    @Transient
    private int hashValue = 0;

    /**
     * Version de la Clase
     */
    private static final long serialVersionUID = 1L;

    /**
     * Clave primaria de la Entidad TbpmFieldTransactionMaping
     */
    @EmbeddedId
    private TbpmFieldTransactionMapingKey pk;

    @Column(name = "FIELDSCREEN", nullable = true)
    /**
     * Nombre del campo para la pantalla
     */
    private String fieldscreen;

    /** Contructor por defecto */
    public TbpmFieldTransactionMaping() {
    }

    /**
     * Contructor de TbpmFieldTransactionMaping
     * 
     * @param pPk Clave Primaria del entity
     */
    public TbpmFieldTransactionMaping(TbpmFieldTransactionMapingKey pPk) {
        this();
        this.pk = pPk;
    }

    /**
     * Metodo que entrega datos de la tabla dada la clave primaria.
     * 
     * @param pEntityManager referencia de la session a obtener datos del bean.
     * @param pKey Caleve primaria del bean.
     * @return TbpmFieldTransactionMaping
     */
    public static TbpmFieldTransactionMaping find(EntityManager pEntityManager, TbpmFieldTransactionMapingKey pKey)
            throws Exception {
        TbpmFieldTransactionMaping obj = pEntityManager.find(TbpmFieldTransactionMaping.class, pKey);
        return obj;
    }

    /**
     * Entrega la Clave primaria de TbpmFieldTransactionMaping
     * 
     * @return El objeto que referencia a la Clave primaria de TbpmFieldTransactionMaping
     */
    public TbpmFieldTransactionMapingKey getPk() {
        return this.pk;
    }

    /**
     * Fija un nuevo valor a la Clave primaria de TbpmFieldTransactionMaping
     * 
     * @param pPk El objeto que referencia a la nueva Clave primaria de TbpmFieldTransactionMaping
     */
    public void setPk(TbpmFieldTransactionMapingKey pPk) {
        this.pk = pPk;
    }

    /**
     * Obtiene el valor de fieldscreen
     * 
     * @return valor de fieldscreen
     */
    public String getFieldscreen() {
        return this.fieldscreen;
    }

    /**
     * Fija el valor de fieldscreen
     * 
     * @param pFieldscreen nuevo Valor de fieldscreen
     */
    public void setFieldscreen(String pFieldscreen) {
        this.fieldscreen = pFieldscreen;
    }

    @Override
    public boolean equals(Object rhs) {
        if (rhs == null) {
            return false;
        }
        if (!(rhs instanceof TbpmFieldTransactionMaping)) {
            return false;
        }
        TbpmFieldTransactionMaping that = (TbpmFieldTransactionMaping) rhs;
        if ((this.getPk() == null) || (that.getPk() == null)) {
            return false;
        }
        return (this.getPk().equals(that.getPk()));
    }

    /**
     * Implementaci�n del metodo hashCode de la la entidad TbpmFieldTransactionMaping
     * 
     * @return el hashCode la instancia
     */
    @Override
    public int hashCode() {
        if (this.hashValue == 0) {
            int result = 17;
            if (this.getPk() == null) {
                result = super.hashCode();
            } else {
                result = this.getPk().hashCode();
            }
            this.hashValue = result;
        }
        return this.hashValue;
    }

    /** Implementaci�n toString */
    @Override
    public String toString() {
        Field[] fs = this.getClass().getDeclaredFields();
        String data = "";
        for (Field f : fs) {
            try {
                String name = f.getName();
                if (f.getType().getName().compareTo("java.util.Set") == 0) {
                    continue;
                }
                if ((name.compareTo("hashValue") == 0) || (name.compareTo("serialVersionUID") == 0)) {
                    continue;
                }
                data += name + "=" + f.get(this) + ";";
            } catch (Exception e) {
                continue;
            }
        }
        if (data.compareTo("") == 0) {
            data = super.toString();
        }
        return data;
    }

    /** Implementaci�n de la creaci�n de un bean en blanco TbpmFieldTransactionMaping */
    @Override
    public Object createInstance() {
        TbpmFieldTransactionMaping instance = new TbpmFieldTransactionMaping();
        instance.setPk(new TbpmFieldTransactionMapingKey());
        return instance;
    }

    /**
     * Clona la entidad TbpmFieldTransactionMaping
     * 
     * @see com.fp.dto.hb.HibernateBean#cloneMe()
     */
    @Override
    public Object cloneMe() throws CloneNotSupportedException {
        TbpmFieldTransactionMaping p = (TbpmFieldTransactionMaping) this.clone();
        p.setPk((TbpmFieldTransactionMapingKey) this.pk.cloneMe());
        return p;
    }

    // Metodos manuales.

    /** Sentecia que entrega una lista de TbpmFieldTransactionOrigin dado un codigo de transaccion. */
    private static final String HQL_FIELDS = "from TbpmFieldTransactionMaping t where t.pk.transactionmodule = :module  "
            + "and t.pk.transactioncode = :transaction and t.pk.transactionversion = :version  ";

    /**
     * Metodo que entrega una lista de registros de la tabla TbpmFieldTransactionOrigin dado un codigo de transaccion.
     * 
     * @param pEntityManager Referencia a la session de la base de datos.
     * @param pGroupcode Codigo de grupo a obtener una lista de usuarios.
     * @return List<TbpmGroupsUsers>
     * @throws Exception
     */
    @SuppressWarnings("unchecked")
    public static List<TbpmFieldTransactionMaping> find(EntityManager pEntityManager, String pModule,
            Integer pTransaction, Integer pVersion) throws Exception {
        Query qry = pEntityManager.createQuery(TbpmFieldTransactionMaping.HQL_FIELDS);
        qry.setParameter("module", pModule);
        qry.setParameter("transaction", pTransaction);
        qry.setParameter("version", pVersion);
        return qry.getResultList();

    }
}
